<?php
/**
 * Created by JetBrains PhpStorm.
 * User: erikasouza
 * Date: 13/11/12
 * Time: 16:20
 * To change this template use File | Settings | File Templates.
 */
namespace Estoque\Logic\FechamentoDia;

use \Estoque\Util\Parametros;
use \Geral\Entities\Expautfilial;
use \Geral\Entities\Venda;
use \Estoque\Logic\Exception\ExceptionExportPosFechDia;

use \Setforms2\Runtime\Helper\Procedure\Param;
use \Setforms2\Runtime\Helper\Procedure;


class ExportPosFechamentoDia
{


    private $paramExport;
    private $paramsExport;
    private $diaFech;
    private $diaDtProc;


    public function __construct($filial, $nrorg, $dtProc){
        /** @var $expautfilialRepository \Geral\Repositories\Expautfilial */
        $expautfilialRepository = Expautfilial::getRepository();
        $this->paramsExport = $expautfilialRepository->consultaParamExportacao($filial, $nrorg);

        $fechamentoMes = new FechamentoMes();
        $this->diaFech = $fechamentoMes->consultaDataFechMes($nrorg, $filial, $dtProc);

        $diaDtProc = \Geral\Util\DateUtil::getDia(\Geral\Util\DateUtil::getDataDeString($dtProc));
        $this->diaDtProc = $diaDtProc;
    }


    public function exportacaoPosFechamentoDia($nrorg, $filial, $dtProc, $dtProcProx){
        // Exportacao e relatorios geral.
        $this->validaRMC($nrorg, $filial, $dtProc);
        if ($this->paramsExport) {
            /** @var $registro Expautfilial */
            foreach ($this->paramsExport as $registro){
                $this->paramExport = $registro;

                // Exportacao e relatorios específicos de cliente.
                $class = ExportFactory::getInstance(
                    $this->paramExport['CDRELATEXP'], $nrorg, $filial, $dtProc,
                    $this->paramExport['NRDIAARQEXP'], $dtProcProx, $this->paramExport['NMARQTXTEXP']
                );

                if ($class !== false) {
                    $class->executaProcedure($nrorg, $filial, $dtProc);

                    // @todo Falta implementar futuramente.
                    $class->executaRelatorio();
                }
            }
        }

        return true;
    }


    private function validaRMC($nrorg, $filial, $dtProc){
        $RMC = Parametros::getConsisteRMC();
        if ($RMC === 'S') {
            $param = array($nrorg, $filial, $dtProc, 'O');

            $dadosVenda = Venda::getObjectByWhere(
                'NRORG = ? AND CDFILIAL = ? AND DTENTRVENDA = ? AND IDSITUVENDA = ?',
                $param,
                'CDCAIXA, DTENTRVENDA'
            );

            $dadosUsrRMC = Usrrmc01::getObjectByWhere(
                'USR_FILIAL = ? AND TO_DATE(USR_DTRMC) = ?',
                array($filial, $dtProc)
            );

            if ($dadosVenda OR $dadosUsrRMC) {
                ExceptionExportPosFechDia::erroRmcNaoGerado();
            }
        }

        return true;
    }

}
