package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginPMEFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.pages.ElaboracaoCardapioPMEPage;
import com.javaseleniumtemplate.pages.MainPage;
import com.javaseleniumtemplate.pages.TipodeCardapioPage;
import org.testng.Assert;
import org.testng.annotations.Test;

public class TipodeCardapioTest extends TestBase {
    MainPage mainPage;
    MainFlows mainFlows;
    TipodeCardapioPage tipodecardapiopage;
    LoginPMEFlows loginpmeflows;


    //Tests
    @Test
    public void adicionartipodecardapio() {
        mainPage = new MainPage();

        loginpmeflows = new LoginPMEFlows();
        mainFlows = new MainFlows();
        tipodecardapiopage = new TipodeCardapioPage();

        String usuario = "francielly.teste";
        String senha = "Teknisa2022";
        String arvcardp = "Brunch";
        String codigo = "29";
        String tipocard = "Brunch reunião";
        String msgesperada = "Salvo com sucesso!";

        loginpmeflows.efetuarloginpme(usuario, senha);
        tipodecardapiopage.AcessarTela();
        tipodecardapiopage.AdicionarArvoreTipodeCardapio(arvcardp);
        tipodecardapiopage.AdicionarTipoCardapio(codigo, tipocard);
        tipodecardapiopage.AdicionarConfigdoServico();
        tipodecardapiopage.AdicionarUnidadePorTipodeCardapio();

        String statusatual = tipodecardapiopage.RetornaMsgSalvoComSucesso();

        Assert.assertEquals(statusatual, msgesperada);


    }

    //Test 2 - GERAR RELATÓRIO TIPO DE CARDÁPIO
    @Test
    public void GerarRelatTipoCardapio() {
        mainPage = new MainPage();

        loginpmeflows = new LoginPMEFlows();
        mainFlows = new MainFlows();
        tipodecardapiopage = new TipodeCardapioPage();

        String usuario = "francielly.teste";
        String senha = "Teknisa2022";


        loginpmeflows.efetuarloginpme(usuario, senha);
        tipodecardapiopage.AcessarTela();
        tipodecardapiopage.GerarRelatorioTipodeCardapio();
    }

    //TEST 3 - GERAR RELATÓRIO TIPO DE CARDÁPIO POR UNIDADE
    @Test
    public void GerarRelatTipoCardUnidade() {
        mainPage = new MainPage();

        loginpmeflows = new LoginPMEFlows();
        mainFlows = new MainFlows();
        tipodecardapiopage = new TipodeCardapioPage();

        String usuario = "francielly.teste";
        String senha = "Teknisa2022";


        loginpmeflows.efetuarloginpme(usuario, senha);
        tipodecardapiopage.AcessarTela();
        tipodecardapiopage.GerarRelatorioTipoCardUnidade();

    }

    //TEST 4 - GERAR RELATÓRIO UNIDADE POR TIPO DE CARDÁPIO
    @Test
    public void GerarRelatUnidadeporTipoCard() {
        mainPage = new MainPage();

        loginpmeflows = new LoginPMEFlows();
        mainFlows = new MainFlows();
        tipodecardapiopage = new TipodeCardapioPage();

        String usuario = "francielly.teste";
        String senha = "Teknisa2022";


        loginpmeflows.efetuarloginpme(usuario, senha);
        tipodecardapiopage.AcessarTela();
        tipodecardapiopage.GerarRelatorioUnidadeTipoCard();

    }


    //TEST 4 - TIPO DE CARDAPIO POR UNIDADE
    @Test
    public void TipodeCardapioPorUnidade() {
        mainPage = new MainPage();

        loginpmeflows = new LoginPMEFlows();
        mainFlows = new MainFlows();
        tipodecardapiopage = new TipodeCardapioPage();

        String usuario = "francielly.teste";
        String senha = "Teknisa2022";
        String msgesperada = "Salvo com sucesso!";


        loginpmeflows.efetuarloginpme(usuario, senha);
        tipodecardapiopage.AcessarTela();
        tipodecardapiopage.AdicionarTipoCardAgregada();

        String statusatual = tipodecardapiopage.RetornaMsgSalvoComSucesso();

        Assert.assertEquals(statusatual, msgesperada);
    }
}

